import pyglet

pyglet.options['audio'] = ('openal', 'directsound', 'alsa', 'silent')
from pyglet import media

class Sound(object):
    def __init__(self):
        self._playing = True
        self._sound_sources = {}
        self._player_list = []
    
    def loadSound(self, filename):
        if self._sound_sources.has_key(filename):
            return self._sound_sources[filename]
        else:
            s = media.load(filename, streaming=False)
            self._sound_sources[filename] = s
            return s
    
    def playSound(self, filename, loop=False):
        s = self.loadSound(filename)
        if loop:
            s.eos_action = media.Player.EOS_LOOP
        s.play()
        return s

    def playMusic(self, filename):
        sound = pyglet.media.load(filename, streaming=True)
        sound.play()
        return sound
    
    def update(self):
        if self._playing:
            media.dispatch_events()
    
    def stop(self):
        for p in self._player_list:
            p.pause()
        self._player_list = []
        self._playing = False
    
sound = Sound()
